---
category: Reference
title: Reference
index: true

order: 40

bodyclass: docs
layout: docs
type: markdown
---

# Reference

The Reference section contains detailed authoritative reference
material such as command-line options, configuration options,
and API calling parameters.

- [istioctl](./istioctl.html). Describes the usage and option of the `istioctl` command-line
tool.

- [Routing and Traffic Management](./routing-and-traffic-management.html). Describes how to 
configure Istio's Layer 4 & 7 routing logic.

- [Attribute Vocabulary](./attribute-vocabulary.html). Describes the base attribute
vocabulary used for policy and control.

- [Glossary](./glossary.html). A glossary of common Istio terms.

- [Release Notes](./release-notes.html). What's been happening with Istio.

- [Roadmap](./release-roadmap.html). What Istio will become in the coming months.

- [Writing Configuration](./writing-config.html). How to write Istio config YAML content.

- Contributing to the Docs

    - [Editing Docs](./editing.html). Lets you start editing this
    site's documentation.
    
    - [Creating a Pull Request](./creating-a-pull-request.html). Shows you
    how to create a GitHub pull request in order to submit your docs for approval.
    
    - [Writing a New Topic](./writing-a-new-topic.html). Explains the
    mechanics of creating new documentation pages.
    
    - [Staging Your Changes](./staging-your-changes.html). Explains how
    to test out your changes locally before submitting them.
    
    - [Reviewing Doc Issues](./reviewing-doc-issues.html). Explains
    the process involved in accepting documentation updates.
    
    - [Style Guide](./style-guide.html). Explains the dos and donts
    of writing Istio docs.
