---
category: Tasks
title: Tasks
index: true

order: 20

bodyclass: docs
layout: docs
type: markdown
---

# Tasks

Tasks show you how to do a single specific targeted
activity with the Istio system.

- [Installation](./istio-installation.html). This task shows you how to
  setup the Istio service mesh.

- [Integrating Services into the Mesh](./integrating-services-into-istio.html). This task shows you how to
  integrate your applications with the Istio service mesh.

- [Configuring Ingress/Egress with Envoy](./ingress-egress-envoy.html). This task shows you how to
  setup the Istio ingress controller and the egress proxy.

- [Adding Resilience Features](./resilience-features.html). This task shows you how to
  setup timeouts, retries, and circuit breakers.

- [Configuring Request Routing](./request-routing.html). This task shows you how to
  configure dynamic request routing based on weights and HTTP headers.

- [Fault Injection](./fault-injection.html). This task shows how to
  inject failures into your application.

- [Enabling Istio-Auth](./istio-auth.html). This task shows you how to
  setup Istio-Auth to provide mutual TLS authentication between services.

- [Collecting Metrics and Logs](./metrics-logs.html). This task shows you how to
  configure Mixer to collect metrics and logs from Envoy instances in
  every Pod.

- [Configuring Mixer](./configuring-mixer.html). This task shows you how to
  configure Mixer.
